<?php
/*
  Plugin Name: SEOMOV Currency Converter
  Plugin URI: http://seomov.com/wordpress-widgets/currency-converter/
  Description: SEOMOV currency converter for any currency in the world.
  Version: 1.0
  Author: SEOMOV.com
  Author URI: http://seomov.com/
  License: GPLv2
 */


//register the uninstall function
register_uninstall_hook(__FILE__, 'seomov_cc_uninstall');

function seomov_cc_uninstall() {
    delete_option('widget_seomov_cc_widget');
}

require_once("functions.php");
static $currency_list;


// use widgets_init action hook to execute custom function
add_action('widgets_init', 'load_seomov_cc');

//register our widget
function load_seomov_cc() {
    register_widget('seomov_cc_widget');
}

//boj_widget_my_info class
class seomov_cc_widget extends WP_Widget {

    //process the new widget
    function seomov_cc_widget() {
        $widget_ops = array(
            'classname' => 'smcc',
            'description' => 'SEOMOV Currency Converter for any currency in the world.'
        );
        $this->WP_Widget('seomov_cc_widget', 'SEOMOV Currency Converter', $widget_ops);
    }

    //build the widget settings form
    function form($instance) {

        if (empty( $currency_list )) {
            $file_location = dirname(__FILE__) . "/currencies.ser";
            if ($fd = fopen($file_location, 'r')) {
                $currency_list_ser = fread($fd, filesize($file_location));
                fclose($fd);
            }

            $currency_list = array();
            $currency_list = unserialize($currency_list_ser);
        }

        $defaults = array(
            'title'=>'SGD',
            'sm_title' => 'Currency Converter',
            'sm_t_txt_clr_cstm' => '',
            'sm_t_txt_clr' => '#000000',
            'sm_t_size' => '14',
            'sm_t_bg' => '#BBBBBB',
            'sm_t_bg_cstm' => '',
            'def_amount' => '100',
            'def_from' => 'USD',
            'def_to' => 'SGD',
            'width' => '150',
            'text_size' => '12',
            'text_align' => 'center',
            'text_clr' => '#000000',
            'text_clr_cstm' => '',
            'border_clr' => '#BBBBBB',
            'border_clr_cstm' => '',
            'bg_clr' => '#FFFFFF',
            'bg_clr_cstm' => ''
        );

        // Extract value from vars
        $instance = wp_parse_args((array) $instance, $defaults);

        $title = htmlspecialchars($instance['def_to'], ENT_QUOTES);
        $sm_title = htmlspecialchars($instance['sm_title'], ENT_QUOTES);
        $sm_t_size = htmlspecialchars($instance['sm_t_size'], ENT_QUOTES);
        $sm_t_txt_clr = htmlspecialchars($instance['sm_t_txt_clr'], ENT_QUOTES);
        $sm_t_txt_clr_cstm = htmlspecialchars($instance['sm_t_txt_clr_cstm'], ENT_QUOTES);
        $sm_t_size = htmlspecialchars($instance['sm_t_size'], ENT_QUOTES);
        $sm_t_bg = htmlspecialchars($instance['sm_t_bg'], ENT_QUOTES);
        $sm_t_bg_cstm = htmlspecialchars($instance['sm_t_bg_cstm'], ENT_QUOTES);
        $def_amount = htmlspecialchars($instance['def_amount'], ENT_QUOTES);
        $def_from = htmlspecialchars($instance['def_from'], ENT_QUOTES);
        $def_to = htmlspecialchars($instance['def_to'], ENT_QUOTES);
        $width = htmlspecialchars($instance['width'], ENT_QUOTES);
        $text_size = htmlspecialchars($instance['text_size'], ENT_QUOTES);
        $text_align = htmlspecialchars($instance['text_align'], ENT_QUOTES);
        $text_clr = htmlspecialchars($instance['text_clr'], ENT_QUOTES);
        $text_clr_cstm = htmlspecialchars($instance['text_clr_cstm'], ENT_QUOTES);
        $border_clr = htmlspecialchars($instance['border_clr'], ENT_QUOTES);
        $border_clr_cstm = htmlspecialchars($instance['border_clr_cstm'], ENT_QUOTES);
        $bg_clr = htmlspecialchars($instance['bg_clr'], ENT_QUOTES);
        $bg_clr_cstm = htmlspecialchars($instance['bg_clr_cstm'], ENT_QUOTES);
        ?> 
        <p>
            <label for="<?php echo $this->get_field_id('sm_title'); ?>">
                Title : <input class="widefat" name="<?php echo $this->get_field_name('sm_title'); ?>" type="text" value="<?php echo $sm_title; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('sm_t_size'); ?>">
                Title Font-size : <input class="widefat" name="<?php echo $this->get_field_name('sm_t_size'); ?>" type="text" value="<?php echo $sm_t_size; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('sm_t_txt_clr'); ?>">
                Title Text Color : 
                <select id="<?php echo $this->get_field_id('sm_t_txt_clr'); ?>" name="<?php echo $this->get_field_name('sm_t_txt_clr'); ?>" style="width:200px;">
                    <?php echo cc_color_list($sm_t_txt_clr); ?>         
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('sm_t_txt_clr_cstm'); ?>">
                Custom Title Text Color : <input class="widefat" name="<?php echo $this->get_field_name('sm_t_txt_clr_cstm'); ?>" type="text" value="<?php echo $sm_t_txt_clr_cstm; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('sm_t_bg'); ?>">
                Title Background-color : 
                <select id="<?php echo $this->get_field_id('sm_t_bg'); ?>" name="<?php echo $this->get_field_name('sm_t_bg'); ?>" style="width:200px;">
                    <?php echo cc_color_list($sm_t_bg); ?>         
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('sm_t_bg_cstm'); ?>">
                Custom Title Background-color : <input class="widefat" name="<?php echo $this->get_field_name('sm_t_bg_cstm'); ?>" type="text" value="<?php echo $sm_t_bg_cstm; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('def_amount'); ?>">
                Default Amount : <input class="widefat" name="<?php echo $this->get_field_name('def_amount'); ?>" type="text" value="<?php echo $def_amount; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('def_from'); ?>">
                Form Currency :
                <select id="<?php echo $this->get_field_id('def_from'); ?>" name="<?php echo $this->get_field_name('def_from'); ?>">
                    <?php echo cc_country_list($def_from, $currency_list); ?>         
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('def_to'); ?>">
                To Currency : 
                <select id="<?php echo $this->get_field_id('def_to'); ?>" name="<?php echo $this->get_field_name('def_to'); ?>">
                    <?php echo cc_country_list($def_to, $currency_list); ?>         
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('width'); ?>">
                Width : <input class="widefat" name="<?php echo $this->get_field_name('width'); ?>" type="text" value="<?php echo $width; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('text_size'); ?>">
                Text Size : <input class="widefat" name="<?php echo $this->get_field_name('text_size'); ?>" type="text" value="<?php echo $text_size; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('text_align'); ?>">
                Text Align : 
                <select id="<?php echo $this->get_field_id('text_align'); ?>" name="<?php echo $this->get_field_name('text_align'); ?>" style="width:200px;">
                    <option value="left" <?php echo selected($text_align, 'left'); ?>>Left</option>     
                    <option value="center" <?php echo selected($text_align, 'center'); ?>>Center</option>     
                    <option value="right" <?php echo selected($text_align, 'right'); ?>>right</option>     
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('text_clr'); ?>">
                Text Color :
                <select id="<?php echo $this->get_field_id('text_clr'); ?>" name="<?php echo $this->get_field_name('text_clr'); ?>" style="width:200px;">
                    <?php echo cc_color_list( $text_clr ); ?>         
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('text_clr_cstm'); ?>">
                Custom Text Color : <input class="widefat" name="<?php echo $this->get_field_name('text_clr_cstm'); ?>" type="text" value="<?php echo $text_clr_cstm; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('border_clr'); ?>">
                Border Color: 
                <select id="<?php echo $this->get_field_id('border_clr'); ?>" name="<?php echo $this->get_field_name('border_clr'); ?>" style="width:200px;">
                    <?php echo cc_color_list($border_clr); ?>         
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('border_clr_cstm'); ?>">
                Custom Border Color : <input class="widefat" name="<?php echo $this->get_field_name('border_clr_cstm'); ?>" type="text" value="<?php echo $border_clr_cstm; ?>" />
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('c'); ?>">
                Background Color : 
                <select id="<?php echo $this->get_field_id('bg_clr'); ?>" name="<?php echo $this->get_field_name('bg_clr'); ?>" style="width:200px;">
                    <?php echo cc_color_list($bg_clr); ?>         
                </select>
            </label>
        </p>
        <p>
            <label for="<?php echo $this->get_field_id('bg_clr_cstm'); ?>">
                Custom Background Color : <input class="widefat" name="<?php echo $this->get_field_name('bg_clr_cstm'); ?>" type="text" value="<?php echo $bg_clr_cstm; ?>" />
            </label>
        </p>
            <label for="<?php echo $this->get_field_id('title'); ?>">
                <input type="hidden" id="<?php echo $this->get_field_id( 'title' );?>" name="<?php echo $this->get_field_id( 'title' );?>" value="<?php echo $title;?>" />
            </label>

        <?php
    }

    //save the widget settings
    function update($new_instance, $old_instance) {
        $instance = $old_instance;
        
        $instance['bg_clr_cstm'] = strip_tags(stripslashes($new_instance['bg_clr_cstm']));
        $instance['bg_clr'] = strip_tags(stripslashes($new_instance['bg_clr']));
        $instance['border_clr_cstm'] = strip_tags(stripslashes($new_instance['border_clr_cstm']));
        $instance['border_clr'] = strip_tags(stripslashes($new_instance['border_clr']));
        $instance['text_clr_cstm'] = strip_tags(stripslashes($new_instance['text_clr_cstm']));
        $instance['text_clr'] = strip_tags(stripslashes($new_instance['text_clr']));
        $instance['text_size'] = strip_tags(stripslashes($new_instance['text_size']));
        $instance['text_align'] = strip_tags(stripslashes($new_instance['text_align']));
        $instance['width'] = strip_tags(stripslashes($new_instance['width']));
        $instance['sm_title'] = strip_tags(stripslashes($new_instance['sm_title']));
        $instance['sm_t_bg_cstm'] = strip_tags(stripslashes($new_instance['sm_t_bg_cstm']));
        $instance['sm_t_bg'] = strip_tags(stripslashes($new_instance['sm_t_bg']));
        $instance['sm_t_txt_clr_cstm'] = strip_tags(stripslashes($new_instance['sm_t_txt_clr_cstm']));
        $instance['sm_t_txt_clr'] = strip_tags(stripslashes($new_instance['sm_t_txt_clr']));
        $instance['sm_t_size'] = strip_tags(stripslashes($new_instance['sm_t_size']));
        $instance['title'] = strip_tags(stripslashes($new_instance['def_to']));

        $instance['def_amount'] = strip_tags(stripslashes($new_instance['def_amount']));
        $instance['def_from'] = strip_tags(stripslashes($new_instance['def_from']));
        $instance['def_to'] = strip_tags(stripslashes($new_instance['def_to']));
        
        //check color format
        $instance['bg_clr_cstm'] = chk_color( $new_instance['bg_clr_cstm'] )?$new_instance['bg_clr_cstm']:'';
        $instance['border_clr_cstm'] = chk_color( $new_instance['border_clr_cstm'] )?$new_instance['border_clr_cstm']:'';
        $instance['text_clr_cstm'] = chk_color( $new_instance['text_clr_cstm'] )?$new_instance['text_clr_cstm']:'';
        $instance['sm_t_bg_cstm'] = chk_color( $new_instance['sm_t_bg_cstm'] )?$new_instance['sm_t_bg_cstm']:'';
        $instance['sm_t_bg_cstm'] = chk_color( $new_instance['sm_t_bg_cstm'] )?$new_instance['sm_t_bg_cstm']:'';
        $instance['sm_t_txt_clr_cstm'] = chk_color( $new_instance['sm_t_txt_clr_cstm'] )?$new_instance['sm_t_txt_clr_cstm']:'';

        return $instance;
    }

    //display the widget
    function widget($args, $instance) {
        extract($args);
        echo $before_widget;

        if (empty($currency_list)) {
            $file_location = dirname(__FILE__) . "/currencies.ser";
            if ($fd = fopen($file_location, 'r')) {
                $currency_list_ser = fread($fd, filesize($file_location));
                fclose($fd);
            }

            $currency_list = array();
            $currency_list = unserialize($currency_list_ser);
        }

        $plugin_url = trailingslashit(get_bloginfo('wpurl')) . PLUGINDIR . '/' . dirname(plugin_basename(__FILE__));
        $bg_clr_fnt = empty( $instance['bg_clr_cstm'] ) ? $instance['bg_clr'] :$instance['bg_clr_cstm'];
        $border_clr_fnt = empty( $instance['border_clr_cstm'] ) ? $instance['border_clr'] :$instance['border_clr_cstm'];
        $text_clr_fnt = empty( $instance['text_clr_cstm'] ) ? $instance['text_clr'] :$instance['text_clr_cstm'];
        $sm_t_bg_fnt = empty( $instance['sm_t_bg_cstm'] ) ? $instance['sm_t_bg'] :$instance['sm_t_bg_cstm'];
        $sm_t_txt_clr_fnt = empty( $instance['sm_t_txt_clr_cstm'] ) ? $instance['sm_t_txt_clr'] :$instance['sm_t_txt_clr_cstm'];
        ?>
        <style>
            div#seomov_cc{
                width: <?php echo $instance['width']; ?>px;
                font-size: <?php echo $instance['text_size']; ?>px;
                text-align: center;
                color: <?php echo $text_clr_fnt; ?>;
                border: 1px solid <?php echo $border_clr_fnt; ?>;
                background-color:<?php echo $bg_clr_fnt; ?>;
                padding:0 0 5px 0;
                margin: 0 auto;
            }

            div#seomov_cc label{
                text-align: center;
                display:block;
                padding: 1px 10px 2px;
            }
            div#seomov_cc p{
                text-align: <?php echo $instance['text_align']; ?>;
            }

            div#seomov_cc input{
                border: 1px solid #BBBBBB;
            }

            div#seomov_cc select, div#seomov_cc input, div#seomov_cc p{
                width:100%!important;
                padding:0;
                margin:0;
            }

            div#seomov_cc .sm_title{
                background-color:<?php echo $sm_t_bg_fnt; ?>;
                font-size:<?php echo $instance['sm_t_size']; ?>px;
                font-weight:800;
                text-align:center;
                color:<?php echo $sm_t_txt_clr_fnt;?>;
                line-height:<?php echo $instance['sm_t_size'] + 20; ?>px;
                height:<?php echo $instance['sm_t_size'] + 20; ?>px;
                margin:0 auto;
                padding:0;
            }

            div#seomov_cc .c_submit{
                display: block;
                margin-top: 5px;
            }
            div#seomov_cc #sm_error{
                display: block;
            }

            div#seomov_cc #sm_emsg{
                color:red;
                font-size:14px;
                font-weight:800;
            }

            div#seomov_cc .sm_error,div#seomov_cc .sm_cc{
                display:none;
            }
            
            div#seomov_cc .link{
                padding-top:3px;
            }

        </style>

        <script type="text/javascript">
            (function($) {
                $(document).ready(function() {
                    function chkNumber(el) {
                        if (isNaN(el)) {
                            return false;
                        } else {
                            return true;
                        }
                    }

                    function hideError() {
                        $("#sm_emsg").html("System Error");
                        $("#seomov_cc .sm_error").hide();
                        $("div#seomov_cc .sm_cc").hide();
                    }

                    function showError(msg) {
                        $("#sm_emsg").html(msg);
                        $("#seomov_cc .sm_error").css('display', 'block');
                    }

                    function getJsonData() {
                        hideError();
                        var sm_amount = $("#sm_amount").val();
                        var sm_from = $("#sm_from").val();
                        var sm_to = $("#sm_to").val();

                        if (chkNumber(sm_amount)) {
                            //check
                            $.ajax({
                                type: 'POST',
                                url: '<?php echo $plugin_url . "/getConverter.php"; ?>',
                                data: {
                                    'amount': sm_amount,
                                    'from': sm_from,
                                    'to': sm_to
                                },
                                async: true,
                                timeout: 15000,
                                dataType: "json",
                                beforeSend: function(xhr) {
                                    $("div#seomov_cc .sm_cing").slideDown();
                                },
                                complete: function(xhr, textStatus) {
                                    //Handle the complete event
                                    if (textStatus == "timeout" || textStatus == "notmodified" || textStatus == "error") {
                                        $("div#seomov_cc .sm_cing").slideUp(300, function() {
                                            showError("Time Out");
                                        })
                                    }
                                },
                                success: function(response) {
                                    if (response.error == 0) {
                                        $("div#seomov_cc .sm_cing").slideUp(300, function() {
                                            $("#sm_cval").val(response.c_val);
                                            $("#sm_date").html('Rates on : ' + response.c_date_d);
                                            $("div#seomov_cc .sm_cc").css('display', 'block');
                                        })
                                    } else {
                                        $("div#seomov_cc .sm_cing").slideUp(300, function() {
                                            showError(response.status);
                                        })
                                    }
                                }
                            });
                        } else {
                            showError("Please fill a number");
                        }
                    }

                    //run currency converter
                    getJsonData();
                    //amount
                    $("#sm_amount").bind('keyup', function() {
                        getJsonData();
                    })

                    $("#sm_from,#sm_to").bind('change', function() {
                        getJsonData();
                    })
                })
            })(jQuery);
        </script>

        <div id="seomov_cc">
            <?php echo '<p class="sm_title">' . $instance['sm_title'] . ' </p>'; ?>
            <label for="SMCC Amount">
                <p> Amount :</p>
                <p>
                    <input class="widefat" id="sm_amount" name="sm_amount" type="text" value="<?php echo $instance['def_amount']; ?>" />
                </p>
            </label>
            <label for="SMCC Form">
                <p>Form Currency :</p>
                <p>
                    <select id="sm_from" name="sm_from">
                        <?php echo cc_country_list($instance['def_from'], $currency_list); ?>         
                    </select>
                </p>
            </label>
            <label for="SMCC To">
                <p>To Currency : </p>
                <select id="sm_to" name="sm_to">
                    <?php echo cc_country_list($instance['def_to'], $currency_list); ?>       
                </select>
            </label>
            <label for="SMCC Converter value" class="sm_cing">
                <p> Converting...</p>
            </label>
            <label for="SMCC Converter value" class="sm_cc">
                <p> is :</p> <input class="widefat" id="sm_cval" name="sm_cval" type="text" value=""/>
                <p class="link"><a href="http://seomov.com/wordpress-widgets/currency-converter/" rel="nofollow"><span id="sm_date"></span></a></p>
            </label>
            <label for="SMCC Error" class="sm_error">
                <p><em id="sm_emsg">System Error</em></p> 
            </label>
        </div>
        <?php
        echo $after_widget;
    }

}
?>
